#!/usr/bin/perl -- -*-perl-*-
###################################################
# procgi.pl
# copyright 1995 Progress software
# copyright 2001 Mark Newnham (mark@newnhams.com)
# Issued under the GPL license. 
# CGI is a powerful module, see the doc at
# http://www.cpan.org for more info
###################################################
use CGI qw/:standard/;
 
$SIG{'TERM'} = sub { exit(0); };
 
##################################################
# load the PROGRESS environment
##################################################
 
$DLC = "/usr/dlc";
$PROPATH = "/opt/apache/lib/htdocs";
$TERM = "ansi";
$PROEXE = $DLC . "/bin/_progres";
 
$ENV{"DLC"} = $DLC;
$ENV{"PROPATH"} = $PROPATH;
$ENV{"TERM"} = $TERM;
 
open(STDERR,">/tmp/procgi.err");
 
$query = new CGI();
 
$path_info = $query->path_info();
 
##################################################
# Make sure we have logged on,
# you can use this for login validation
###################################################
$ENV{"USERID"} = $query->remote_user();
 
####################################################
# The first element of the path is where the procgi.pf
# file for the application is located
####################################################
@procgi_path = split(/\//, $path_info);
$PROCGI="$PROPATH/$procgi_path[1]/procgi.pf";
 
####################################################
# remove the leading slash, PROPATH must be set correctly
# for this to run
#####################################################
$path_info = substr($path_info,1);
 
###################################################
# send all the received variables out to the env
###################################################
&exportEnv();
 
$SIG{ALRM}= sub { $errorText = "Timeout waiting for response from database" ;
                                  &url_error();
                                  exit(0)
                                };
 
##################################################
# execute the progress executable 
##################################################
alarm(60);
##################################################
#A choice here, either generate the header here, or
# in the progress program itself. You can do some
# fairly sophisticated things with the perl
# cgi module
##################################################
#print $query->header("text/html");
$pid = system($PROEXE, "-pf" ,  $PROCGI , "-p" , $path_info);
exit(0);
 
#########################################################
#################### Support Routines ###################
#########################################################
 
 
 
 
# Parse and then export the arguments into environment variables
sub exportEnv
{
  local ($i) = 0;
  local ($key,$var);
  local (@names);
 
  @names=$query->param();
 
  # Export form fields to the environment
  $i = 0;
  foreach $key (@names) {
      # Export positional parameters as VAR1 ... VARn
      $ENV{"VAR" . $i} = $key;
      # Copy associated value to $var
      $var = $query->param($key);
      # Convert null's delimiting multi-selected values to commas.
      $var =~ tr/\0/,/;
      # Export to environment
      $ENV{"$key"} = $var;
      $i++;
  }
 
  # Number of positional parameters goes in $VARCOUNT
  $ENV{"VARCOUNT"} = $i;
  # Export $FORM_FIELDS as a comma delimited list of the form field names
  $ENV{"FORM_FIELDS"} = @names;
 
}
 
 
sub url_error {
 
    print ($query->header("text/html") ,
           $query->start_html("Error in procgi handler"),
           $query->h1("ProCGI2 Handler error"),
           $query->Dump,
           $query->end_html);
    print $errorText;
    exit(0);
 }
 
